include \masm32\include\masm32rt.inc

; since we don't write anything to the code section, we can drop
; the data section: 1536 instead of 2560 bytes

.code

GdiPlusDll	db	"Bmp2Png.dll",0	; the name of the DLL

Call_Bmp2Png	db	"Bmp2Png",0		; first export
Call_FreeGdiPlus	db	"FreeGdiPlus",0	; second & last export

TestPic	db	"Test_me.gif",0	; if no commandline arg found

AppName	db	"GdiPlus for converting images to png",0
AskUser	db	"Convert an image to PNG?",0
B2P_done	db	"Conversion ok",0
B2P_err	db	"Error during conversion",0
ErrNoGP	db	"No GdiPlus.dll on this pc, sorry",0

start:
push ebx	; two extra registers needed
push esi

	invoke GetCommandLine
	mov esi,eax	; start CL = exe
	xor eax,eax	; zero
	xor ecx,ecx	; 0+32=space
	add ecx,32	; default delimiter to arg 1 is space
	mov al,[esi]	; byte operand
	cmp al,34	; exe name starts with Chr$(34)?
	jne Cl0	; no, so it's a space
	mov cl,al	; delimiter is 34 (default)

Cl0:	inc esi
	mov al,[esi]
	test al,al
	jz NoArg1	; oops, a null byte - no arguments
	cmp al,cl
	jne Cl0

	mov al,[esi+1]	; this is probably not needed, since
	test al,al		; apparently Windows puts a blank
	jz NoArg1		; before the nullbyte
	mov al,[esi+2]	; so that nullbyte is usually in esi+2

	test al,al
	jz NoArg1	; No args

	xor ecx,ecx	; delimiter found; default for arg 1 is NULL
Cl1a:	inc esi		; so where is first byte of arg 1?
	mov al,[esi]
	cmp al,34
	jb Cl1a	; below 34: space or tab
	ja Arg1_found ; above 34 means esi points to start of pathname

	mov cl,34	; delimiter for arg 1 is 34
	mov edx,esi	; start address arg 1
	inc esi		; skip the 34, GdiPlus wants plain path names

Cl1b:	inc edx
	mov al,[edx]
	cmp al,cl
	jne Cl1b	; loop until 34 found
	xor al,al	; clear eax
	mov [edx],al	; replace 34 with a nullbyte (this is a hack, yes)
	jmp Arg1_found

NoArg1:
	mov esi,offset TestPic	; if not commandline arg, take test.bmp
Arg1_found:

.if rv(MessageBox,NULL,addr AskUser,addr AppName,MB_YESNO)==IDYES
	invoke LoadLibrary, addr GdiPlusDll
	.if eax==0	; GdiPlus.dll not found
	  invoke MessageBox,NULL,addr ErrNoGP,addr AppName,MB_OK
	  ret
	.endif
	mov ebx, eax	; handle to dll

	invoke GetProcAddress, ebx, addr Call_Bmp2Png
	push esi	; bitmap file name
	call eax	; convert first BMP
	.IF eax
	  invoke MessageBox,NULL,addr B2P_err,addr AppName,MB_OK
	.else
	  invoke MessageBox,NULL,addr B2P_done,addr AppName,MB_OK
	.endif

; you could do multiple conversions -
; no init or FreeGdiPlus needed,
; as this is handled by Bmp2Png.dll
; invoke GetProcAddress, ebx, addr Call_Bmp2Png
; push offset Pic2
; call eax	; convert second BMP

	invoke GetProcAddress, ebx, addr Call_FreeGdiPlus
	call eax			; free GdiPlus
	invoke FreeLibrary, ebx	; and our little DLL
.endif
pop esi
pop ebx
invoke ExitProcess,0
end start
